<?php

// A historical record of permissions as configured by ProsePoint 0.03. 
function prosepoint_0_03_permissions() {
  $permissions = array();
  // $permissions_table['anonymous user'] = array (
  $permissions['anon'] = array (
    'access content',
    'access comments',
    'post comments',
    'access site-wide contact form', 
    'search content',
    'access service links',
  );
  // $permissions_table['authenticated user'] = array (
  $permissions['auth'] = array (
    'access content',
    'access comments',
    'post comments',
    'post comments without approval',
    'access site-wide contact form', 
    'search content',
  );
  $permissions['staff'] = array('access administration menu', 'create ifimage content', 'edit own ifimage content', 'create page content', 'create story content', 'delete own ifimage content', 'delete own page content', 'delete own story content', 'edit own edition content', 'edit own page content', 'edit own story content', 'access user profiles', 'create media content', 'delete own media content', 'edit own media content', );
  $permissions['editor'] = array('access administration menu', 'administer blocks', 'administer comments', 'administer site-wide contact form', 'administer filters', 'create ifimage content', 'edit any ifimage content', 'edit own ifimage content', 'view original images', 'administer menu', 'administer content types', 'administer nodes', 'create edition content', 'create page content', 'create story content', 'create writer content', 'delete any edition content', 'delete any ifimage content', 'delete any page content', 'delete any story content', 'delete any writer content', 'delete own edition content', 'delete own ifimage content',  'delete own page content', 'delete own story content', 'delete own writer content', 'delete revisions', 'edit any edition content', 'edit any page content', 'edit any story content', 'edit any writer content', 'edit own edition content', 'edit own page content', 'edit own story content', 'edit own writer content', 'revert revisions', 'view revisions', 'administer url aliases', 'create url aliases', 'create channel content', 'delete any channel content', 'delete own channel content', 'edit any channel content', 'edit own channel content', 'view channel content', 'administer search', 'use advanced search', 'access administration pages', 'access site reports', 'administer actions', 'administer files', 'administer site configuration', 'select different theme', 'access user profiles', 'administer permissions', 'administer users', 'change own username', 'administer views',
  'clone node', 'clone own nodes', 'access service links', 'administer service links',
  'create media content', 'delete own media content', 'delete any media content', 'edit own media content', 'edit any media content',
  );
  return $permissions;
}

/* Settings for every single module that implements hook_perm, and settings
 * for every single permission must be present. Otherwise complain loudly.
 *
 * Too many times, I've added a new module, then forgot to configure the permissions for it.
 */

function prosepoint_config_permissions_table() {
  $permissions_table = array(
    'admin_menu' => array(
      'access administration menu' => array('staff', 'editor'),
      'display drupal links' => array(),
    ),
    'block' => array(
      'administer blocks' => array('editor', 'administrator'),
      'use PHP for block visibility' => array('administrator'),
    ),
    'clone' => array(
      'clone node' => array('editor'),
      'clone own nodes' => array('editor'),
    ),
    'comment' => array(
      'access comments' => array('anon', 'auth'),
      'administer comments' => array('editor', 'administrator'),
      'post comments' => array('anon', 'auth'),
      'post comments without approval' => array('anon', 'auth'),
    ),
    'composite' => array(
      'edit composite layouts' => array('editor', 'administrator'),
    ),
    'contact' => array(
      'access site-wide contact form' => array('anon', 'auth'),
      'administer site-wide contact form' => array('editor', 'administrator'),
    ),
    'content' => array(
      'Use PHP input for field settings (dangerous - grant with care)' => array(),
    ),
    'date_php4' => array(
      'administer date_php4 settings' => array('administrator'),
    ),
    'devel' => array(
      'access devel information' => array(),
      'display source code' => array(),
      'execute php code' => array(),
      'switch users' => array(),
    ),
    'filter' => array(
      'administer filters' => array('administrator'),
    ),
    'imageapi' => array(
      'administer imageapi' => array('editor', 'administrator'),
    ),
    'imagecache' => array(
      'administer imagecache' => array('editor', 'administrator'),
      'flush imagecache' => array('editor', 'administrator'),
      'view imagecache large' => array('anon', 'auth'),
      'view imagecache medium' => array('anon', 'auth'),
      'view imagecache small' => array('anon', 'auth'),
      'view imagecache square' => array('anon', 'auth'),
      'view imagecache thumbnail' => array('anon', 'auth'),
    ),
    'imagefield' => array(
      'view imagefield uploads' => array('anon', 'auth'),
    ),
    'locale' => array(
      'administer languages' => array('editor', 'administrator'),
      'translate interface' => array('editor', 'administrator'),
    ),
    'menu' => array(
      'administer menu' => array('editor', 'administrator'),
    ),
    'node' => array(
      'access content' => array('anon', 'auth'),
      'administer content types' => array('editor', 'administrator'),
      'administer nodes' => array('editor', 'administrator'),
      'create edition content' => array('editor', 'administrator'),
      'create ifimage content' => array('staff', 'editor', 'administrator'),
      'create media content' => array('staff', 'editor', 'administrator'),
      'create page content' => array('staff', 'editor', 'administrator'),
      'create story content' => array('staff', 'editor', 'administrator'),
      'create source content' => array('editor', 'administrator'),
      'delete any edition content' => array('editor', 'administrator'),
      'delete any ifimage content' => array('editor', 'administrator'),
      'delete any media content' => array('editor', 'administrator'),
      'delete any page content' => array('editor', 'administrator'),
      'delete any story content' => array('editor', 'administrator'),
      'delete any source content' => array('editor', 'administrator'),
      'delete own edition content' => array('editor', 'administrator'),
      'delete own ifimage content' => array('staff', 'editor', 'administrator'),
      'delete own media content' => array('staff', 'editor', 'administrator'),
      'delete own page content' => array('staff', 'editor', 'administrator'),
      'delete own story content' => array('staff', 'editor', 'administrator'),
      'delete own source content' => array('editor', 'administrator'),
      'delete revisions' => array('editor', 'administrator'),
      'edit any edition content' => array('editor', 'administrator'),
      'edit any ifimage content' => array('editor', 'administrator'),
      'edit any media content' => array('editor', 'administrator'),
      'edit any page content' => array('editor', 'administrator'),
      'edit any story content' => array('editor', 'administrator'),
      'edit any source content' => array('editor', 'administrator'),
      'edit own edition content' => array('editor', 'administrator'),
      'edit own ifimage content' => array('staff', 'editor', 'administrator'),
      'edit own media content' => array('staff', 'editor', 'administrator'),
      'edit own page content' => array('staff', 'editor', 'administrator'),
      'edit own story content' => array('staff', 'editor', 'administrator'),
      'edit own source content' => array('editor', 'administrator'),
      'revert revisions' => array('staff', 'editor', 'administrator'),
      'view revisions' => array('staff', 'editor', 'administrator'),
    ),
    'path' => array(
      'administer url aliases' => array('editor', 'administrator'),
      'create url aliases' => array('editor', 'administrator'),
    ),
    'pathauto' => array(
      'administer pathauto' => array('editor', 'administrator'),
      'notify of path changes' => array('auth'),
    ),
    'pp' => array(
      'view drafts' => array('staff', 'editor', 'administrator'),
      'view ready for reviews' => array('staff', 'editor', 'administrator'),
    ),
    'pp_ch' => array(
      'administer channels' => array('editor', 'administrator'),
    ),
    'pp_ed' => array(
      'access ProsePoint editor' => array('auth'),
    ),
    'pp_ig' => array(
      'access pp image galleries' => array('anon', 'auth'),
      'administer pp image galleries' => array('editor', 'administrator'),
    ),
    'search' => array(
      'administer search' => array('editor', 'administrator'),
      'search content' => array('anon', 'auth'),
      'use advanced search' => array('staff', 'editor', 'administrator'),
    ),
    'service_links' => array(
      'access service links' => array('anon', 'auth'),
      'administer service links' => array('editor', 'administrator'),
    ),
    'system' => array(
      'access administration pages' => array('staff', 'editor', 'administrator'),
      'access site reports' => array('editor', 'administrator'),
      'administer actions' => array('editor', 'administrator'),
      'administer files' => array('editor', 'administrator'),
      'administer site configuration' => array('editor', 'administrator'),
      'select different theme' => array('editor', 'administrator'),
    ),
    'taxonomy' => array(
      'administer taxonomy' => array('editor', 'administrator'),
    ),
    'user' => array(
      'access user profiles' => array('staff', 'editor', 'administrator'),
      'administer permissions' => array('editor', 'administrator'),
      'administer users' => array('editor', 'administrator'),
      'change own username' => array('editor', 'administrator'),
    ),
    'views' => array(
      'administer views' => array('administrator'),
      'access all views' => array('editor', 'administrator'),
    ),
  );
  return $permissions_table;
}

function prosepoint_config_permissions() {
  global $user;
  $permissions_table = prosepoint_config_permissions_table();

  foreach (module_implements('perm') as $module) {
    if (isset($permissions_table[$module])) {
      $hook_perm = module_invoke($module, 'perm');
      $pp_perms = $permissions_table[$module];

      // Check we have a setting for this individual permission
      foreach ($hook_perm as $perm) {
        if (!array_key_exists($perm, $pp_perms)) {
          drupal_set_message(t('Permission not configured for module ') . $module . ': ' . $perm, 'error');
        }
      }
    }
    else {
      drupal_set_message(t('Permissions not configured for module ') . $module, 'error');
    }
  }

  // Flatten permissions table for later use
  $new_table = array();
  foreach ($permissions_table as $module => $perms) {
    $new_table = array_merge_recursive($new_table, $perms);
  }
  $permissions_table = $new_table;

  // Build a list of applicable roles
  // One advantage of this is that any misspellings are easy to catch - they show up as a new role
  foreach ($permissions_table as $perm) {
    foreach ($perm as $role) {
      $roles[] = $role;
    }
  }
  $roles = array_unique($roles);

  // anon and auth are our own abbreviations
  $role_id = array('anon' => 1, 'auth' => 2);
  foreach ($roles as $role) {
    if ($role != 'anon' && $role != 'auth') {
      $role_id[$role] = install_add_role($role);
    }
  }

  foreach ($role_id as $name => $rid) {
    $permissions_set = array();
    foreach ($permissions_table as $perm => $values) {
      if (in_array($name, $values)) {
        $permissions_set[] = $perm;
      }
    }
    install_set_permissions($rid, $permissions_set);
  }
  
  // Add editor role to first account
  db_query("INSERT INTO {users_roles} (uid, rid) VALUES (%d, %d) ", $user->uid, $role_id['editor']);
}

function prosepoint_add_permission($rid, $perms) {
  $perm_string = db_result(db_query("SELECT perm FROM {permission} WHERE rid = '%d'", $rid));
  if ($perm_string) {
    if (is_array($perms)) {
      $perms = implode(', ', $perms);
    }
    $perm_string .= ', ' . $perms;
    db_query("UPDATE {permission} SET perm = '%s' WHERE rid = %d", $perm_string, $rid);
  }
}

// This function exists because of a historical oversight.
// The administrator role was added in ProsePoint 0.04. New installations from 0.04 onwards have the admin role as rid 5. 
// However, sites installed with 0.03 or earlier may have a user-added role as rid 5 (and administrator as some other rid)
// So, we try to check if rid is the admin role, but we can't be certain. 

function prosepoint_get_admin_rid() {
  $admin_role = db_fetch_object(db_query("SELECT role.rid, role.name, permission.perm FROM {role} role LEFT JOIN {permission} permission ON role.rid = permission.rid WHERE role.rid = %d", 5));
  // We assume admin is rid 5 if it is still named 'administrator'
  return $admin_role->name == 'administrator' ? $admin_role->rid : FALSE;
}

