<?php

function pp_ch_edition_manager() {
  pp_ch_update_channel_editions();  
  return views_embed_view('editions_view');
}

// Note: We intentionally bypass the access permissions of the view, but use our own menu access permissions. 
function pp_ch_latest_edition($term) {
  drupal_set_title(t('@channel', array('@channel' => $term->name)));
  $output = '';
  if ($view = views_get_view('channel_editions_archive')) {
    $view->set_arguments(array($term->tid));
    $result = $view->execute();
    $latest = array_shift($view->result);
    $view->destroy();

    $node = node_load($latest->nid);
    if ($node->nid) {
      // set $page to true so the node title doesn't show
      $output = node_view($node, FALSE, TRUE, TRUE);
    }
    else {
      $output = t('There is no edition scheduled for this channel. You probably want to !link for this channel.', array('!link' => l(t('create a new edition'), 'node/add/edition')));
    }
  }          
  else {
    drupal_set_message(t('ProsePoint error: Missing view %view', array('%view' => 'channel_editions_archive')), 'error');
  }
  return $output;
}

function pp_ch_list($term) {
  drupal_set_title(t('@channel editions', array('@channel' => $term->name)));
  $output = '';
  if ($view = views_get_view('channel_editions_list')) {
    $output = $view->execute_display(null, array($term->tid));
    $view->destroy();
  }         
  else {
    drupal_set_message(t('ProsePoint error: Missing view %view', array('%view' => 'channel_editions_list')), 'error');
  }
  return $output;
}

function pp_ch_archive($term) {
  drupal_set_title(t('@channel archive', array('@channel' => $term->name)));
  $output = '';
  if ($view = views_get_view('channel_editions_archive')) {
    $output = $view->execute_display(null, array($term->tid));
    $view->destroy();
  }          
  else {
    drupal_set_message(t('ProsePoint error: Missing view %view', array('%view' => 'channel_editions_archive')), 'error');
  }
  return $output;
}

