
(function() {
  tinymce.create('tinymce.plugins.Break', {

    init : function(ed, url) {
      var t = this;

      // Register the command so that it can be invoked by using tinyMCE.activeEditor.execCommand();
      ed.addCommand('mceTeaserBreak', function() {
        tinyMCE.activeEditor.execCommand('mceInsertContent', false, t.__to_html(url, '<!--break-->'));
      });

      // Register image button
      ed.addButton('break', {
        title : 'Teaser Break',
        cmd : 'mceTeaserBreak',
        image : url + '/img/break.gif'
      });

      ed.onBeforeSetContent.add(function(ed, o) {
        o.content = t.__to_html(url, o.content);
      });
      ed.onGetContent.add(function(ed, o) {
        o.content = t.__from_html(o.content);
      });
    },

    // convert internal notation to html
    __to_html : function(url, co) {
      // alert('__to_html: input: ' + co);
      var data = co.replace(/<\!--break-->/gi, function (a, b) {
        var output = '<img id="teaser-break" src="' + url + '/img/breaktext.gif' + '" style="display: block" />';
        return output;
      });
      // alert('__to_html: output: ' + data);
      return data;
    },

    // convert html to internal notation
    __from_html : function(co) {
      // alert('__from_html: input: ' + co);
      data = co;
      var data = co.replace(/<img id="teaser-break".*?breaktext.gif[^>]*>/gi, function (a, b) {
        return '<!--break-->';
      });      
      // alert('__from_html: output: ' + data);
      return data;
    },


    /**
     * Creates control instances based in the incomming name. This method is normally not
     * needed since the addButton method of the tinymce.Editor class is a more easy way of adding buttons
     * but you sometimes need to create more complex controls like listboxes, split buttons etc then this
     * method can be used to create those.
     *
     * @param {String} n Name of the control to create.
     * @param {tinymce.ControlManager} cm Control manager to use inorder to create new control.
     * @return {tinymce.ui.Control} New control instance or null if no control was created.
     */
    createControl : function(n, cm) {
      return null;
    },

    /**
     * Returns information about the plugin as a name/value array.
     * The current keys are longname, author, authorurl, infourl and version.
     *
     * @return {Object} Name/value array containing information about the plugin.
     */
    getInfo : function() {
      return {
        longname : 'ProsePoint Editor Break',
        author : 'Beng Tan',
        authorurl : 'http://thinkleft.com.au',
        infourl : 'http://www.prosepoint.org',
        version : "0.01"
      };
    }
  });

  // Register plugin
  tinymce.PluginManager.add('break', tinymce.plugins.Break);
})();